# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Test-Without-Module
Version:	0.21
Release:	2.%{__distinit}%{__distvers}
Summary:	Test fallback behavior in absence of modules
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Test-Without-Module
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-Without-Module-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	sed
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
# Test Suite
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Digest::MD5)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(warnings)
# Optional Tests
BuildRequires:	perl(Module::Load::Conditional)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description
This module allows you to deliberately hide modules from a program even
though they are installed. This is mostly useful for testing modules that
have a fallback when a certain dependency module is not installed.

%prep
%setup -q -n Test-Without-Module-%{version}

# Remove bogus exec permissions
chmod -c -x lib/Test/Without/Module.pm Changes Texts/article.txt

# Fix line endings
sed -i -e 's/\r$//' Changes Texts/article.txt

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README.mkdn Texts/article.txt
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::Without::Module.3*

%changelog
* Fri Jul 14 2023 Paul Howarth <paul@city-fan.org> - 0.21-2
- Drop MODULE_COMPAT dependency from Fedora 38 onwards

* Mon Dec 12 2022 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Harden test suite against changed error message coming with 5.38
- Use SPDX-format license tag

* Fri Jun  7 2019 Paul Howarth <paul@city-fan.org> - 0.20-9
- Perl 5.30 rebuild

* Wed Apr  4 2018 Paul Howarth <paul@city-fan.org> - 0.20-5
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Mon Apr 10 2017 Paul Howarth <paul@city-fan.org> - 0.20-1
- Update to 0.20
  - Make tests more resilient against old versions of Carp.pm (CPAN RT#121002)
  - Typo fixes
  - Rework test suite, move author tests below xt/
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Fri Mar 31 2017 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19
  - Make error message more like the original Perl error message
  - Makefile.PL overhaul
  - Generate README.mkdn
- Add patch to fix test to match error message on old distributions

* Fri Oct  7 2016 Paul Howarth <paul@city-fan.org> - 0.18-6
- Classify buildreqs by usage
- Simplify find command using -delete

* Mon Sep  1 2014 Paul Howarth <paul@city-fan.org> - 0.18-1
- Update to 0.18
  - Eliminate segfault on Perl 5.8 (CPAN RT#98207)
  - Only add the @INC hook once (CPAN RT#91857)
  - Updated documentation
- Stop build process pointlessly killing itself on old distributions
- Fix typo in documentation that results in broken deps on old distributions
- Drop %%defattr, redundant since rpm 4.4

* Mon Jul  2 2012 Paul Howarth <paul@city-fan.org> - 0.17-7
- BR: perl(Carp), perl(Digest::MD5), perl(File::Spec) and perl(File::Temp)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Jul  7 2011 Paul Howarth <paul@city-fan.org> - 0.17-6
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Mar 18 2011 Paul Howarth <paul@city-fan.org> - 0.17-5
- Import from Fedora

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 22 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.17-3
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu Jul 22 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.17-2
- Remove executable permissions
- Dos2unix the README and Changes file
- Americanise the summary

* Sun Jun 27 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> 0.17-1
- Specfile autogenerated by cpanspec 1.78
